---
title: Array.prototype.includes()
slug: Web/JavaScript/Reference/Global_Objects/Array/includes
tags:
  - Array
  - JavaScript
  - Method
  - Prototype
  - Reference
  - inArray
  - in_array
  - polyfill
---
<div>{{JSRef}}</div>

<p>The <code><strong>includes()</strong></code> method determines whether an array includes a certain value among its entries, returning <code>true</code> or <code>false</code> as appropriate.</p>

<div>{{EmbedInteractiveExample("pages/js/array-includes.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>arr</var>.includes(<var>valueToFind</var>[, <var>fromIndex</var>])
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>valueToFind</var></code></dt>
 <dd>
 <p>The value to search for.</p>

 <div class="notecard note">
 <p><strong>Note:</strong> When comparing strings and characters, <code>includes()</code> is <em>case-sensitive</em>.</p>
 </div>
 </dd>
 <dt><code><var>fromIndex</var></code> {{optional_inline}}</dt>
 <dd>The position in this array at which to begin searching for <code><var>valueToFind</var></code>.</dd>
 <dd>The first element to be searched is found at <code><var>fromIndex</var></code> for positive values of <code><var>fromIndex</var></code>, or at <code><var>arr</var>.length + <var>fromIndex</var></code> for negative values of <code><var>fromIndex</var></code> (using the {{interwiki("wikipedia", "absolute value")}} of <code><var>fromIndex</var></code> as the number of elements from the end of the array at which to start the search).</dd>
 <dd>Defaults to <code>0</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Boolean")}} which is <code>true</code> if the value <code><var>valueToFind</var></code> is found within the array (or the part of the array indicated by the index <code><var>fromIndex</var></code>, if specified).</p>

<p>Values of zero are all considered to be equal, regardless of sign. (That is, <code>-0</code> is considered to be equal to both <code>0</code> and <code>+0</code>), but <code>false</code> is <em>not</em> considered to be the same as <code>0</code>.</p>

<div class="note">
<p><strong>Note:</strong> Technically speaking, <code>includes()</code> uses the <code><a href="/en-US/docs/Web/JavaScript/Equality_comparisons_and_sameness#Same-value-zero_equality">sameValueZero</a></code> algorithm to determine whether the given element is found.</p>
</div>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">[1, 2, 3].includes(2)      // true
[1, 2, 3].includes(4)      // false
[1, 2, 3].includes(3, 3)   // false
[1, 2, 3].includes(3, -1)  // true
[1, 2, NaN].includes(NaN)  // true
</pre>

<h3 id="fromIndex_is_greater_than_or_equal_to_the_array_length"><code><var>fromIndex</var></code> is greater than or equal to the array length</h3>

<p>If <code><var>fromIndex</var></code> is greater than or equal to the length of the array, <code>false</code> is returned. The array will not be searched.</p>

<pre class="brush: js notranslate">let arr = ['a', 'b', 'c']

arr.includes('c', 3)    // false
arr.includes('c', 100)  // false
</pre>

<h3 id="Computed_index_is_less_than_0">Computed index is less than 0</h3>

<p>If <code><var>fromIndex</var></code> is negative, the computed index is calculated to be used as a position in the array at which to begin searching for <code><var>valueToFind</var></code>. If the computed index is less or equal than <code>-1 * <var>arr</var>.length</code>, the entire array will be searched.</p>

<pre class="brush: js notranslate">// array length is 3
// fromIndex is -100
// computed index is 3 + (-100) = -97

let arr = ['a', 'b', 'c']

arr.includes('a', -100) // true
arr.includes('b', -100) // true
arr.includes('c', -100) // true
arr.includes('a', -2)   // false
</pre>

<h3 id="includes_used_as_a_generic_method">includes() used as a generic method</h3>

<p><code>includes()</code> method is intentionally generic. It does not require <code>this</code> value to be an Array object, so it can be applied to other kinds of objects (e.g. array-like objects).</p>

<p>The example below illustrates <code>includes()</code> method called on the function's <a href="/en-US/docs/Web/JavaScript/Reference/Functions/arguments">arguments</a> object.</p>

<pre class="brush: js notranslate">(function() {
  console.log(Array.prototype.includes.call(arguments, 'a'))  // true
  console.log(Array.prototype.includes.call(arguments, 'd'))  // false
})('a','b','c') </pre>

<div class="hidden">
<p>Please do not add polyfills on reference articles. For more details and discussion, see <a href="https://discourse.mozilla.org/t/mdn-rfc-001-mdn-wiki-pages-shouldnt-be-a-distributor-of-polyfills/24500">https://discourse.mozilla.org/t/mdn-rfc-001-mdn-wiki-pages-shouldnt-be-a-distributor-of-polyfills/24500</a></p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-array.prototype.includes', 'Array.prototype.includes')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Array.includes")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("TypedArray.prototype.includes()")}}</li>
 <li>{{jsxref("String.prototype.includes()")}}</li>
 <li>{{jsxref("Array.prototype.indexOf()")}}</li>
 <li>{{jsxref("Array.prototype.find()")}}</li>
 <li>{{jsxref("Array.prototype.findIndex()")}}</li>
</ul>
